=== debian/changelog ===
bibletime (3.2.0-1) unstable; urgency=medium

  * Team upload
  * New upstream version 3.2.0
  * Possibly enable unit tests
  * Drop patch that upstream handled differently
  * Drop mips64el quirk

 -- Bastian Germann <bage@debian.org>  Tue, 17 Feb 2026 23:47:41 +0100
