=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_HANDBOOK_PDF=OFF -DBUILD_HOWTO_PDF=OFF

override_dh_auto_test:
	QT_QPA_PLATFORM=offscreen dh_auto_test
